﻿Imports System.ComponentModel
Imports System.Linq.Expressions

Public Class Form1

    Dim sales As List(Of Sales)

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load

        GenerateData()

        'BindingList set as grid's DataSource
        Me.C1FlexGrid1.DataSource = New SortedBindingList(Of Sales)(sales)

    End Sub

    'Refresh the grid and display SortGlyphs
    Private Sub C1FlexGrid1_AfterSort(sender As Object, e As C1.Win.C1FlexGrid.SortColEventArgs) Handles C1FlexGrid1.AfterSort
        Me.C1FlexGrid1.Invalidate()
        Me.C1FlexGrid1.ShowSortAt(e.Order, e.Col)
    End Sub

    Private Sub GenerateData()
        sales = New List(Of Sales)() From
            {
                New Sales() With
                {
                    .Customer = "John Smith",
                    .SaleDate = New DateTime(2008, 1, 1), _
                    .Dealer = "James Franco", _
                    .SaleDetails = New SortedBindingList(Of Book)() From { _
                        New Book() With { _
                            .Title = "Pride And Prejudice", _
                            .Quantity = 1, _
                            .Cost = 25 _
                        }, _
                New Book() With { _
                    .Title = "Jane Eyer", _
                    .Quantity = 2, _
                    .Cost = 35 _
                }, _
                New Book() With { _
                    .Title = "Wuthering Heights", _
                    .Quantity = 1, _
                    .Cost = 55 _
                } _
            } _
  }, New Sales() With { _
        .Customer = "John Ayers", _
        .SaleDate = New DateTime(2008, 1, 2), _
        .Dealer = "Tom Cruise", _
        .SaleDetails = New SortedBindingList(Of Book)() From { _
            New Book() With { _
                .Title = "Emma", _
                .Quantity = 1, _
                .Cost = 80 _
            }, _
            New Book() With { _
                .Title = "Sense And Sensibility", _
                .Quantity = 5, _
                .Cost = 100 _
            }, _
            New Book() With { _
                .Title = "Romeo And Juliet", _
                .Quantity = 3, _
                .Cost = 50 _
            } _
        } _
}, New Sales() With { _
    .Customer = "Pamela Landy", _
    .SaleDate = New DateTime(2008, 1, 3), _
    .Dealer = "Jason Bourne", _
    .SaleDetails = New SortedBindingList(Of Book)() From { _
        New Book() With { _
            .Title = "Persuasion", _
            .Quantity = 40, _
            .Cost = 30 _
        }, _
        New Book() With { _
            .Title = "Oliver Twist", _
            .Quantity = 2, _
            .Cost = 200 _
        } _
    } _
}, New Sales() With { _
.Customer = "Toby McGuire", _
.SaleDate = New DateTime(2008, 1, 2), _
.Dealer = "Steven Buchanan", _
.SaleDetails = New SortedBindingList(Of Book)() From { _
    New Book() With { _
        .Title = "Frankestein", _
        .Quantity = 1, _
        .Cost = 180 _
    }, _
    New Book() With { _
        .Title = "Hamlet", _
        .Quantity = 5, _
        .Cost = 110 _
    }, _
    New Book() With { _
        .Title = "Great Expectations", _
        .Quantity = 3, _
        .Cost = 150 _
    } _
} _
}, New Sales() With { _
.Customer = "Mark Robinson", _
.SaleDate = New DateTime(2008, 1, 3), _
.Dealer = "Will Smith", _
.SaleDetails = New SortedBindingList(Of Book)() From { _
New Book() With { _
    .Title = "Gulliver's Travels", _
    .Quantity = 10, _
.Cost = 310 _
}, _
New Book() With { _
.Title = "Hamlet", _
.Quantity = 2, _
.Cost = 101 _
} _
} _
}, New Sales() With { _
.Customer = "Bruce Banner", _
.SaleDate = New DateTime(2008, 1, 2), _
.Dealer = "Bruce Willis", _
.SaleDetails = New SortedBindingList(Of Book)() From { _
New Book() With { _
.Title = "Robinson Crusoe", _
.Quantity = 1, _
.Cost = 810 _
}, _
New Book() With { _
.Title = "Macbeth", _
.Quantity = 5, _
.Cost = 110 _
}, _
New Book() With { _
.Title = "Treasure Island", _
.Quantity = 3, _
.Cost = 510 _
} _
} _
}, _
New Sales() With { _
.Customer = "Tony Stark", _
.SaleDate = New DateTime(2008, 1, 3), _
.Dealer = "Alex Ford", _
.SaleDetails = New SortedBindingList(Of Book)() From { _
New Book() With { _
.Title = "Dracula", _
.Quantity = 10, _
.Cost = 130 _
}, _
New Book() With { _
.Title = "A Tale of Two Cities", _
.Quantity = 2, _
.Cost = 101 _
} _
} _
}}
    End Sub
    
End Class

Public Class Sales
    Public Sub New()
        SaleDate = DateTime.Now
    End Sub

    Public Property SaleDetails() As SortedBindingList(Of Book)
        Get
            Return m_SaleDetails
        End Get
        Set(value As SortedBindingList(Of Book))
            m_SaleDetails = value
        End Set
    End Property
    Private m_SaleDetails As SortedBindingList(Of Book)


    Public Property Dealer() As String
        Get
            Return m_Dealer
        End Get
        Set(value As String)
            m_Dealer = value
        End Set
    End Property
    Private m_Dealer As String


    Public Property Customer() As String
        Get
            Return m_Customer
        End Get
        Set(value As String)
            m_Customer = value
        End Set
    End Property
    Private m_Customer As String


    Public Property SaleDate() As DateTime
        Get
            Return m_SaleDate
        End Get
        Set(value As DateTime)
            m_SaleDate = value
        End Set
    End Property
    Private m_SaleDate As DateTime


    Public ReadOnly Property TotalAmount() As Decimal
        Get
            System.Diagnostics.Debug.Assert(SaleDetails IsNot Nothing)
            Return SaleDetails.Sum(Function(a) a.TotalAmount)
        End Get
    End Property
End Class

Public Class Book

    Public Property Title() As String
        Get
            Return m_Title
        End Get
        Set(value As String)
            m_Title = value
        End Set
    End Property
    Private m_Title As String
    Public Property Quantity() As Integer
        Get
            Return m_Quantity
        End Get
        Set(value As Integer)
            m_Quantity = value
        End Set
    End Property
    Private m_Quantity As Integer
    Public Property Cost() As Decimal
        Get
            Return m_Cost
        End Get
        Set(value As Decimal)
            m_Cost = value
        End Set
    End Property
    Private m_Cost As Decimal

    Public ReadOnly Property TotalAmount() As Decimal
        Get
            Return Cost * Quantity
        End Get
    End Property
End Class


'SubClassed BindingList<T>
Public Class SortedBindingList(Of T)
    Inherits BindingList(Of T)
    Private _list As List(Of T)
    Private sortDirection As ListSortDirection
    Private sortProperty As PropertyDescriptor

    Private setBaseList As Action(Of SortedBindingList(Of T), List(Of T)) = Sub(a, b) a.ResetItems(b)

    Shared cachedOrderByExpressions As New Dictionary(Of String, Func(Of List(Of T), IEnumerable(Of T)))()

    Public Sub New()
        _list = New List(Of T)()
    End Sub

    Public Sub New(enumerable As IEnumerable(Of T))
        _list = enumerable.ToList()
        setBaseList(Me, _list)
    End Sub

    Public Sub New(list As List(Of T))
        _list = list
        setBaseList(Me, _list)
    End Sub

    Protected Overrides Sub ApplySortCore(prop As PropertyDescriptor, direction As ListSortDirection)
        sortProperty = prop

        Dim orderByMethodName = If(sortDirection = ListSortDirection.Ascending, "OrderBy", "OrderByDescending")
        Dim cacheKey = Convert.ToString(GetType(T).GUID.ToString + prop.Name) & orderByMethodName

        If Not cachedOrderByExpressions.ContainsKey(cacheKey) Then
            CreateOrderByMethod(prop, orderByMethodName, cacheKey)
        End If

        ResetItems(cachedOrderByExpressions(cacheKey)(_list).ToList())
        ResetBindings()
        sortDirection = If(sortDirection = ListSortDirection.Ascending, ListSortDirection.Descending, ListSortDirection.Ascending)
    End Sub


    Private Sub CreateOrderByMethod(prop As PropertyDescriptor, orderByMethodName As String, cacheKey As String)
        Dim sourceParameter = Expression.Parameter(GetType(List(Of T)), "source")
        Dim lambdaParameter = Expression.Parameter(GetType(T), "lambdaParameter")
        Dim accesedMember = GetType(T).GetProperty(prop.Name)
        Dim propertySelectorLambda = Expression.Lambda(Expression.MakeMemberAccess(lambdaParameter, accesedMember), lambdaParameter)
        Dim orderByMethod = GetType(Enumerable).GetMethods().Where(Function(a) a.Name = orderByMethodName AndAlso a.GetParameters().Length = 2).[Single]().MakeGenericMethod(GetType(T), prop.PropertyType)

        Dim orderByExpression = Expression.Lambda(Of Func(Of List(Of T), IEnumerable(Of T)))(Expression.[Call](orderByMethod, New Expression() {sourceParameter, propertySelectorLambda}), sourceParameter)

        cachedOrderByExpressions.Add(cacheKey, orderByExpression.Compile())
    End Sub

    Protected Overrides Sub RemoveSortCore()
        ResetItems(_list)
    End Sub

    Private Sub ResetItems(items As List(Of T))

        MyBase.ClearItems()

        For i As Integer = 0 To items.Count - 1
            MyBase.InsertItem(i, items(i))
        Next
    End Sub

    Protected Overrides ReadOnly Property SupportsSortingCore() As Boolean
        Get
            Return True
        End Get
    End Property

    Protected Overrides ReadOnly Property SortDirectionCore() As ListSortDirection
        Get
            Return sortDirection
        End Get
    End Property

    Protected Overrides ReadOnly Property SortPropertyCore() As PropertyDescriptor
        Get
            Return sortProperty
        End Get
    End Property

    Protected Overrides Sub OnListChanged(e As ListChangedEventArgs)
        _list = MyBase.Items.ToList()
    End Sub
End Class
